package com.test.beans;


import java.util.logging.Logger;

import javax.interceptor.AroundInvoke;
import javax.interceptor.Interceptor;
import javax.interceptor.InvocationContext;


@Logging
@Interceptor
public class LoggingInterceptor {

    private static final Logger LOGGER = Logger.getLogger(LoggingInterceptor.class.getName());

    private static final String FORMAT = "%s intercepting %s %s.%s()";

    private static final String MY_CLASSNAME = LoggingInterceptor.class.getName();

    @AroundInvoke
    public Object aroundInvoke(InvocationContext ctx) throws Exception {
        String targetClass = ctx.getTarget().getClass().getName();
        String targetMethod = ctx.getMethod().getName();
        LOGGER.info(String.format(FORMAT, MY_CLASSNAME, "before", targetClass, targetMethod));
        System.out.println(String.format(FORMAT, MY_CLASSNAME, "before", targetClass, targetMethod));
        Object result = ctx.proceed();
        LOGGER.info(String.format(FORMAT, MY_CLASSNAME, "after", targetClass, targetMethod));
        System.out.println(String.format(FORMAT, MY_CLASSNAME, "before", targetClass, targetMethod));
        return result;
    }
}
